import React, { Component } from 'react';
import PropTypes from 'prop-types';

export default class Star extends Component {
  static propTypes = {
    args: PropTypes.any,
    className: PropTypes.string,
    onClick: PropTypes.func
  };
  static defaultProps = {
    args: null
  }
  constructor(props) {
    super(props);
  }
  getArgs = (e) => {
    var args = this.props.args;
    if (args !== undefined) {
      if (typeof args === 'string' && args === '$event') {
        args = e;
      } else if (Array.isArray(args) && args.indexOf('$event') > -1) {
        args[args.indexOf('$event')] = e;
      }
    } else {
      args = e;
    }
    return args;
  }
  onClick = (e) => {
    if (this.props.onClick) {
      this.props.onClick(this.getArgs(e));
    }
  }
  render() {
    const {args, className, onClick, ...others} = this.props;
    return (
      <i className={`star${className ? ' ' + className : ''}`} {...others} onClick={this.onClick}/>
    );
  }
}
